commit 60e536d6f1682f3009c598db0f9c268db5d1749c
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Mon Nov 28 12:16:21 2022 +0000

    libstdc++: Fix std::string_view for IL32P16 targets
    
    For H8/300 with -msx -mn -mint32 the type of (_M_len - __pos) is int,
    because int is wider than size_t so the operands are promoted.
    
    libstdc++-v3/ChangeLog:
    
            * include/std/string_view (basic_string_view::copy) Use explicit
            template argument for call to std::min<size_t>.
            (basic_string_view::substr): Likewise.

diff --git a/libstdc++-v3/include/std/string_view b/libstdc++-v3/include/std/string_view
index 9ee88836381..23383f578e5 100644
--- a/libstdc++-v3/include/std/string_view
+++ b/libstdc++-v3/include/std/string_view
@@ -299,7 +299,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       {
 	__glibcxx_requires_string_len(__str, __n);
 	__pos = std::__sv_check(size(), __pos, "basic_string_view::copy");
-	const size_type __rlen = std::min(__n, _M_len - __pos);
+	const size_type __rlen = std::min<size_t>(__n, _M_len - __pos);
 	// _GLIBCXX_RESOLVE_LIB_DEFECTS
 	// 2777. basic_string_view::copy should use char_traits::copy
 	traits_type::copy(__str, data() + __pos, __rlen);
@@ -310,7 +310,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       substr(size_type __pos = 0, size_type __n = npos) const noexcept(false)
       {
 	__pos = std::__sv_check(size(), __pos, "basic_string_view::substr");
-	const size_type __rlen = std::min(__n, _M_len - __pos);
+	const size_type __rlen = std::min<size_t>(__n, _M_len - __pos);
 	return basic_string_view{_M_str + __pos, __rlen};
       }
 

